<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>2.0.0 Released - News - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Release notice for HTML Purifier 2.0.0." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, 2.0.0, release, version, news" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">2.0.0 Released</h1>

<div id="content">

<p>
  <strong>HTML Purifier 2.0</strong> is the culmination of two major architectural changes. 
  The first is <a href="../docs/enduser-tidy.html">Tidy</a>, which enables
  HTML Purifier to both natively support 
  deprecated elements and also convert them to standards-compliant 
  alternatives. The second is the
  <a href="../docs/enduser-customize.html">Advanced API</a>,
  which enables users to 
  create new elements and attributes with ease. Keeping in line with a 
  commitment to high quality, there are also five esoteric bug-fixes and a 
  plethora of subtle improvements that enhance the library.
</p>

<xi:include href="download-box.xml" xpointer="xpointer(/*/node())" />

<h2>What is HTML Purifier?</h2>

<p>
  HTML Purifier is a standards-compliant <abbr>HTML</abbr> filter written
  in <abbr>PHP</abbr>. Because it uses whitelists and a comprehensive
  knowledge of the <abbr>HTML</abbr> specification, it is <strong>bullet-proof</strong>
  against <abbr>XSS</abbr>, <strong>fixes malformed input</strong> rather
  than reject it, and is <strong>open and extensible</strong>. Don't
  take my word for it: try the <a href="../demo.php">demo</a> or
  read how HTML Purifier <a href="../comparison.html">compares</a> to 
  other libraries.
</p>

<h2>What is Tidy?</h2>

<p>
  While Tidy may remind of HTMLTidy, our Tidy has nothing to do with
  Dave Raggett's library. Previously, HTML Purifier was really fussy
  about deprecated elements and always tried to convert them to
  standards-compliant alternatives. Now, you can pick: stay with the
  deprecated (but valid) elements or clean them up! Read more about
  it in the <a href="../docs/enduser-tidy.html">Tidy documentation</a>.
</p>

<h2>What is the Advanced <abbr>API</abbr>?</h2>

<p>
  The Advanced <abbr>API</abbr> is a powerful new interface users can
  use to customize HTML Purifier with their own custom attributes
  and elements. Read more about
  it in the <a href="../docs/enduser-customize.html">
  customization documentation</a>.
</p>

<h2>Backwards-incompatible changes</h2>

<p>
  There are a few behavioral changes that may break code written for
  esoteric features of the previous versions:
</p>

<ul class="long">
  <li>
    <strong>Previous customizations to HTMLDefinition will now
    throw fatal errors.</strong> This is easy to fix: set
    <code>$config->set('HTML', 'DefinitionID', 'your-name-here')</code>
    and then read the documentation on the
    <a href="../docs/enduser-customize.html">advanced <abbr>API</abbr></a>
    to convert your code to the brand new features. (Trust me: it's a lot
    easier to write.)
  </li>
  <li>
    <strong>Configuration objects are finalized when used.</strong>
    This means you cannot set another configuration value after
    you have already used it to purify some text. Set the <code>autoFinalize</code>
    member variable to false in order to work around this, or try to
    re-structure your code so that it is not necessary.
  </li>
  <li>
    <strong>Interface for HTMLPurifier_Lexer::create() changed.</strong>
    This factory method no longer accepts a prototype as a parameter:
    instead, it requires a configuration object.  To overload the Lexer
    with your own custom one, set <code>$config->set('Core', 'LexerImpl', $lexer)</code>.
    Note however, that the lexer selection has gotten a bit smarter, so
    you may want to just let HTML Purifier do its thing.
  </li>
  <li>
    <strong>Caching for HTMLDefinition added, please ensure the cache
    output directory is writeable.</strong> While this change won't
    break anything per-say, you'll be missing out on a tremendous
    speed increase if you don't ensure that
    <code>library/HTMLPurifier/DefinitionCache/Serializer</code> is
    writeable by <abbr>PHP</abbr>. In the event this is not possible,
    you can change the cache output directory using
    <code>$config->set('Cache', 'SerializerPath', $path);</code> (please
    use absolute paths).
  </li>
</ul>

<p>
  I take backwards-compatibility <em>very</em> seriously, so if you have
  any problems pop on over to the <a href="http://htmlpurifier.org/phorum/">forums</a>
  and I'll do whatever I can to help you.
</p>

<h2>What is new?</h2>

<p>
  Tidy and the Advanced API are all fine and dandy, but they're aimed towards
  the advanced user. HTML Purifier 2.0.0 also has a number of extra
  features that target the common guy too! Here are the more notable ones:
</p>

<ul class="long">
  <li>
    New <strong>%HTML.Allowed</strong> configuration directive lets you set allowed attributes
    and elements in one go! Use a TinyMCE style format: "<code>a[href|title],b,i</code>"
  </li>
  <li>
    The configuration object gives friendlier error messages when things
    go wrong.
  </li>
  <li>
    HTML Purifier works in <strong><abbr>PHP</abbr> 4.3.2</strong>. That's
    pretty ancient, but it's good to know that you can still use HTML Purifier
    on those crappy webhosts that refuse to upgrade.
  </li>
  <li>
    When running in Transitional mode (HTML 4.01 Transitional or XHTML 1.0
    Transitional), HTML Purifier will be as lazy as possible when fixing
    things up: this means that deprecated elements will be preserved in
    these doctypes.
  </li>
</ul>

<p>
  As usual, you can see a full list of changes, bugfixes and other
  miscellanea in
  <a href="http://htmlpurifier.org/svnroot/htmlpurifier/tags/2.0.0/NEWS">News</a>.
</p>

<h2>Spread the word!</h2>

<p>
  Used HTML Purifier and liked it? Interested but will investigate later?
  Disbelieving at the prospect of bullet-proof <abbr>XSS</abbr> protection?
  Whatever your thoughts, help spread the word!
</p>

<ul>
  <li><a href="http://www.dzone.com/links/html_purifier_200_released.html">Vote up HTML Purifier on <strong>DZone</strong></a></li>
  <li><a href="http://programming.reddit.com/info/2016n/comments">Read HTML Purifier at <strong>Reddit</strong></a></li>
  <li><a href="http://digg.com/programming/HTML_Purifier_2_0_0_released">Digg HTML Purifier on <strong>Digg</strong></a></li>
  <li><a href="http://del.icio.us/post?v=4&amp;noui&amp;url=http://htmlpurifier.org/news/2.0.0-released.html">Bookmark HTML Purifier on <strong>del.icio.us</strong></a></li>
  <li><a href="http://freshmeat.net/projects/htmlpurifier">Rate HTML Purifier on <strong>freshmeat.net</strong></a></li>
  <li><a href="http://sourceforge.net/projects/htmlpurifier">Nominate HTML Purifier on <strong>sourceforge.net</strong></a></li>
</ul>

</div>
</div>
</body>
</html>
